// ADOConn.h: interface for the ADOConn class.
//
//////////////////////////////////////////////////////////////////////
#pragma once
#include <Shlwapi.h>
#include <vector>

#pragma comment(lib,"shlwapi.lib")
//XPMSADO15룬ȻWIN7汾XPXP潫޷ʹ
//no_namespace rename("EOF","adoEOF")rename("BOF","adoBOF")
#import "D:\\develop\\dll_lib\\msado15.dll" no_namespace rename("EOF", "adoEOF")

//ʾADOXռ䡱1д뼴
#import "D:\\develop\\dll_lib\\msadox.dll"

#define DAT_NAME "reply.mdb"
#define TABLE_NAME "reply"
#define COLUMN_ID "id"
#define COLUMN_KEY "_key"
#define COLUMN_REPLY "_reply"
#define COLUMN_COMMENT "_comment"
#define COLUMN_CLASS "_cid"
#define SQL_LENGTH 512

#define TABLE_CLASS_NAME "reply_class"
#define COLUMN_CLASS_ID "id"
#define COLUMN_CLASS_COMMENT "_comment"

#define DEFAULT_CLASS "ճ"

#define KEY_SIZE 1024
#define REPLY_SIZE 1024

struct ReplyMsg
{
	char _id[5];				//ݿID
	char _cid[5];				//ID
	char _key[KEY_SIZE];
	char _reply[REPLY_SIZE];
	char _comment[MAX_PATH];
	std::vector<CString> _key_part;

	ReplyMsg()
	{
		_key_part.reserve(10);
		memset(_id,0,sizeof(_id));
		memset(_cid,0,sizeof(_cid));
		memset(_key,0,sizeof(_key));
		memset(_reply,0,sizeof(_reply));
		memset(_comment,0,sizeof(_comment));
	}

	void Init(char *key,char *replay,char *comment)
	{
		strcpy_s(_key,sizeof(_key),key);
		strcpy_s(_reply,sizeof(_reply),replay);
		strcpy_s(_comment,sizeof(_comment),comment);
		ParseKey();
	}

	void Init(char *id,char *key,char *replay,char *comment,char *cid)
	{
		strcpy_s(_id,sizeof(_id),id);
		strcpy_s(_key,sizeof(_key),key);
		strcpy_s(_reply,sizeof(_reply),replay);
		strcpy_s(_comment,sizeof(_comment),comment);
		strcpy_s(_cid,sizeof(_cid),cid);
		ParseKey();
	}

private:
	void ParseKey()
	{
		char tmp[1024];
		strncpy_s(tmp,1024,_key,sizeof(_key));
		char *pSplit = NULL;
		char *pNext = NULL;
		int nCount = 0;
		const char *delim = " ";
		pSplit = strtok_s(tmp,delim,&pNext);
		while(pSplit != NULL)
		{
			CString tempKey(pSplit);
			_key_part.push_back(tempKey);
			pSplit = strtok_s(NULL,delim,&pNext);
		}
	}
};

//ظ
struct MsgClass
{
	char _id[5];
	char _comment[MAX_PATH];

	MsgClass()
	{
		memset(_id,0,sizeof(_id));
		memset(_comment,0,sizeof(_comment));
	}

	void Init(char *comment)
	{
		strcpy_s(_comment,sizeof(_comment),comment);
	}

	void Init(char *id,char *comment)
	{
		strcpy_s(_id,sizeof(_id),id);
		strcpy_s(_comment,sizeof(_comment),comment);
	}

};

class ADOConn  
{
private:
	//һָConnectionָ
	_ConnectionPtr m_pConnection;
	static ADOConn *_instance;
	ADOConn();
public:
	static ADOConn* getInstance();
	virtual ~ADOConn();
	BOOL OnInitADOConn();
	void AddTable();
	void DeleteTable(char *tName);
	void AddRecord(ReplyMsg* pMsg);
	int TotalRecords(void);
	void QueryRecords(std::vector<ReplyMsg> *_vector);
	void DeleteRecord(ReplyMsg* pMsg);
	void UpdateRecord(ReplyMsg* pMsg);
	bool ExecuteSql(char* strSql);
	bool IsInit(void);
	//class 
	void AddClassTable(void);
	void AddClassRecord(MsgClass *pClass);
	void DeleteClassRecord(MsgClass *pClass);
	void UpdateClassRecord(MsgClass *pClass);
	void QueryClassRecords(std::vector<MsgClass> *_vector);
};