#include "stdafx.h"
#include "ADOConn.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif
using namespace ADOX;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

ADOConn* ADOConn::_instance = NULL;

ADOConn::ADOConn()
{
	m_pConnection = NULL;
	if(!AfxOleInit())//COMĳʼ
		AfxMessageBox("COMʼʧ");
	//::CoInitialize(NULL);////MFC̳ʼOLE/COM⻷ 
	this->_instance = this;
}

ADOConn::~ADOConn()
{
	//رռ¼
	if(m_pConnection != NULL)
		m_pConnection->Close();
	//::CoUninitialize();//MFCͷ
}

ADOConn* ADOConn::getInstance()
{
	if(_instance == NULL)
		_instance = new ADOConn;
	return _instance;
}

BOOL ADOConn::OnInitADOConn()
{
	try                 
	{	
		char path[MAX_PATH];
		CString strPath;
		::GetModuleFileName(NULL,path,MAX_PATH);
		strPath = path;
		strPath = strPath.Left(strPath.ReverseFind('\\')+1);
		strPath += DAT_NAME;

		m_pConnection.CreateInstance("ADODB.Connection");//ʼConnectionָ
		// 򿪱Accessstudent.mdb
		char strname[SQL_LENGTH] = {0};
		//Microsoft.ACE.OLEDB.12.0access2007֮ݿʹõ
		//Microsoft.Jet.OLEDB.4.0access2003ݿʹõ
		//˴ΪAccessַADOSQLҲǴģʽͬľǱ仯˴ַ
		sprintf_s(strname,"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=%s",strPath);

		CFileFind m_FileFind;
		if(!m_FileFind.FindFile(strPath))
		{
			//ûиmdbļȥ
			_CatalogPtr m_pCatalog = NULL;
			//__uuidofȻ
			HRESULT hr = m_pCatalog.CreateInstance("ADOX.Catalog");
			if(FAILED(hr))
				_com_issue_error(hr);
			else
				m_pCatalog->Create(strname); //Create mdb
		}
		//ݿ
		m_pConnection->Open(strname,"","",adModeUnknown);
	}
	catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
		return FALSE;
	} 
	return TRUE;
}

///////////////Ϣݿ//////////////////////
void ADOConn::AddTable()
{
	try
	{
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"select * from %s",TABLE_NAME);
		bool exist = ExecuteSql(strSQL);
		if (!exist)
		{
			memset(strSQL,0,SQL_LENGTH);
			sprintf_s(strSQL,"create table %s(%s counter(1,1) primary key,%s varchar(255),%s varchar(255),%s varchar(255),%s int)"
				,TABLE_NAME,COLUMN_ID,COLUMN_KEY,COLUMN_REPLY,COLUMN_COMMENT,COLUMN_CLASS);
			_variant_t RecordsAffected;
			m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText); 
		}
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}


void ADOConn::DeleteTable(char *tName)
{
	try
	{
		_variant_t RecordsAffected;
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"drop table %s",tName);
		m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText);
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}
////////////SQL书//////////
//create table %s(id counter(1,1) primary key,username varchar(50),age int)
//AddColumn ALTER TABLE test_table ADD newcolumn1 INTEGER
//AddColumn ALTER TABLE new ADD newcolumn1 INTEGER
//SetIdIndex CREATE UNIQUE INDEX id ON new(ID)

void ADOConn::AddRecord(ReplyMsg* pMsg)
{
	try
	{
		_variant_t RecordsAffected;
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"insert into %s(%s,%s,%s,%s) values ('%s','%s','%s',%d)",TABLE_NAME,
			COLUMN_KEY,COLUMN_REPLY,COLUMN_COMMENT,COLUMN_CLASS,pMsg->_key
			,pMsg->_reply,pMsg->_comment,atoi(pMsg->_cid));
		m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText); 
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}


int ADOConn::TotalRecords(void)
{
	try
	{
		_RecordsetPtr m_pRecordset;
		_variant_t RecordsAffected;
		m_pRecordset = m_pConnection->Execute("select count(*) from test_table where id > 0"
			,&RecordsAffected,adCmdText); 
		_variant_t vCount = m_pRecordset->GetCollect((long)0); 
		///ȡõһֶεֵvCount 
		m_pRecordset->Close();///رռ¼ 
		return vCount.lVal;
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
	return 0;
}


void ADOConn::QueryRecords(std::vector<ReplyMsg> *_vector)
{
	if(_vector == NULL)
		return;
	_vector->clear();
	try
	{
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"select * from %s",TABLE_NAME);
		_RecordsetPtr m_pRecordset;
		_variant_t RecordsAffected; 
		m_pRecordset = m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText);
		_variant_t v_id;
		_variant_t v_key;
		_variant_t v_reply;
		_variant_t v_comment;
		_variant_t v_cid;
		while(!m_pRecordset->adoEOF)
		{
			v_id = m_pRecordset->GetCollect(COLUMN_ID);
			v_key = m_pRecordset->GetCollect(COLUMN_KEY);
			v_reply = m_pRecordset->GetCollect(COLUMN_REPLY);
			v_comment = m_pRecordset->GetCollect(COLUMN_COMMENT);
			v_cid = m_pRecordset->GetCollect(COLUMN_CLASS);
			_bstr_t _id = (_bstr_t)v_id;
			_bstr_t _key = (_bstr_t)v_key;
			_bstr_t _reply = (_bstr_t)v_reply;
			_bstr_t _comment = (_bstr_t)v_comment;
			_bstr_t _cid = (_bstr_t)v_cid;
			char *szID = _id;
			char *szKey = _key;
			char *szReply = _reply;
			char *szComment = _comment;
			char *szCID = _cid;
			ReplyMsg _msg;
			_msg.Init(szID,szKey,szReply,szComment,szCID);
			if(_vector != NULL)
				_vector->push_back(_msg);
			m_pRecordset->MoveNext();
		}
		m_pRecordset->Close();
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}


void ADOConn::DeleteRecord(ReplyMsg* pMsg)
{
	try
	{
		_variant_t RecordsAffected;
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"delete from %s where %s=%d",TABLE_NAME,COLUMN_ID,atoi(pMsg->_id));
		m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText); 
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}


void ADOConn::UpdateRecord(ReplyMsg* pMsg)
{
	try
	{
		_variant_t RecordsAffected;
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"update %s set %s='%s',%s='%s',%s='%s',%s='%s' where %s=%d",
			TABLE_NAME,COLUMN_KEY,pMsg->_key,COLUMN_REPLY,pMsg->_reply,COLUMN_COMMENT,
			pMsg->_comment,COLUMN_CLASS,pMsg->_cid,COLUMN_ID,atoi(pMsg->_id));
		m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText); 
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}

bool ADOConn::ExecuteSql(char* strSql)
{
	try
	{
		_variant_t RecordsAffected;
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,strSql);
		m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText); 
	}catch(_com_error e)
	{
		return false;
	}
	return true;
}


bool ADOConn::IsInit(void)
{
	return m_pConnection != NULL;
}

///////////////Ϣݿ//////////////////////
void ADOConn::AddClassTable(void)
{
	try
	{
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"select * from %s",TABLE_CLASS_NAME);
		bool exist = ExecuteSql(strSQL);
		if (!exist)
		{
			memset(strSQL,0,SQL_LENGTH);
			sprintf_s(strSQL,"create table %s(%s counter(1,1) primary key,%s varchar(255))"
				,TABLE_CLASS_NAME,COLUMN_CLASS_ID,COLUMN_CLASS_COMMENT);
			_variant_t RecordsAffected;
			m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText);
			//һĬϵ
			MsgClass m_class;
			m_class.Init(DEFAULT_CLASS);
			AddClassRecord(&m_class);
		}
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}

void ADOConn::AddClassRecord(MsgClass *pClass)
{
	try
	{
		_variant_t RecordsAffected;
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"insert into %s(%s) values ('%s')",TABLE_CLASS_NAME,
			COLUMN_CLASS_COMMENT,pClass->_comment);
		m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText); 
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}

void ADOConn::DeleteClassRecord(MsgClass *pClass)
{
	try
	{
		_variant_t RecordsAffected;
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"delete from %s where %s=%d",TABLE_CLASS_NAME,COLUMN_CLASS_ID,atoi(pClass->_id));
		m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText); 
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}

void ADOConn::UpdateClassRecord(MsgClass *pClass)
{
	try
	{
		_variant_t RecordsAffected;
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"update %s set %s='%s' where %s=%d",
			TABLE_CLASS_NAME,COLUMN_CLASS_COMMENT,pClass->_comment,COLUMN_CLASS_ID,atoi(pClass->_id));
		m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText); 
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}

void ADOConn::QueryClassRecords(std::vector<MsgClass> *_vector)
{
	if(_vector == NULL)
		return;
	_vector->clear();
	try
	{
		char strSQL[SQL_LENGTH] = {0};
		sprintf_s(strSQL,"select * from %s",TABLE_CLASS_NAME);
		_RecordsetPtr m_pRecordset;
		_variant_t RecordsAffected; 
		m_pRecordset = m_pConnection->Execute(strSQL,&RecordsAffected,adCmdText);
		_variant_t v_id;
		_variant_t v_comment;
		while(!m_pRecordset->adoEOF)
		{
			v_id = m_pRecordset->GetCollect(COLUMN_CLASS_ID);
			v_comment = m_pRecordset->GetCollect(COLUMN_CLASS_COMMENT);
			_bstr_t _id = (_bstr_t)v_id;
			_bstr_t _comment = (_bstr_t)v_comment;
			char *szID = _id;
			char *szComment = _comment;
			MsgClass _class;
			_class.Init(szID,szComment);
			if(_vector != NULL)
				_vector->push_back(_class);
			m_pRecordset->MoveNext();
		}
		m_pRecordset->Close();
	}catch(_com_error e)
	{
		AfxMessageBox(e.ErrorMessage());
	}
}